{ CALEPIN.EXE
  Gestion d'un calepin
  Copyright Olivier Dahan
  CompuServe: 100531,163

  V 1.0  Mars 1996
}

unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, StdCtrls, Buttons, ExtCtrls,
  DBCtrls, Mask;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    T_calepin: TTable;
    ds_Calepin: TDataSource;
    DBGrid1: TDBGrid;
    T_calepinNom: TStringField;
    T_calepinSocit: TStringField;
    T_calepinTlphone: TStringField;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBComboBox1: TDBComboBox;
    DBRadioGroup1: TDBRadioGroup;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBMemo1: TDBMemo;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBMemo2: TDBMemo;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Bevel1: TBevel;
    Label9: TLabel;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    Label10: TLabel;
    Bevel2: TBevel;
    T_calepinClInterne: TIntegerField;
    T_calepinPrnom: TStringField;
    T_calepinCivilit: TStringField;
    T_calepinTypeContact: TStringField;
    T_calepinTlcopie: TStringField;
    T_calepinEmail: TStringField;
    T_calepinAdresse: TMemoField;
    T_calepinCodePostal: TStringField;
    T_calepinVille: TStringField;
    T_calepinCommentaire: TMemoField;
    T_calepinDatedeCration: TDateTimeField;
    T_calepinDerniremodification: TDateTimeField;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure T_calepinNewRecord(DataSet: TDataset);
    procedure T_calepinBeforePost(DataSet: TDataset);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure DBRadioGroup1Click(Sender: TObject);
    procedure ds_CalepinDataChange(Sender: TObject; Field: TField);
  private
    ChampIndex : String; { recherche incrmentale multiindex }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
{ fermeture de la fiche, donc ici de l'application }
close;
end;

procedure TForm1.T_calepinNewRecord(DataSet: TDataset);
begin
{ Date/heure de cration }
T_calepinDatedeCration.value:=Now;
{ type de contact par dfaut }
T_CalepinTypeContact.Value:=DBRadioGroup1.Items[0];
{ Focus sur le nom  saisir }
DBEdit1.SetFocus;
end;

procedure TForm1.T_calepinBeforePost(DataSet: TDataset);
begin
{ Date/heure de modification }
T_calepinDerniremodification.value:=now;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
{ Annulation de la recherche incrmentale ventuellement en cours }
T_Calepin.CancelRange;
{ Vidage de l'Edit servant  la recherche }
Edit1.Text:='';
{ gestion du changement d'index }
case RadioGroup1.ItemIndex of
0: begin
     { index par nom }
     T_calepin.IndexName:='IX_Nom';
     { placement des champs dans la grille }
     T_CalepinNom.index:=0;
     T_CalepinSocit.index:=1;
     T_CalepinTlphone.index:=2;
     { nom du champ index en cours }
     ChampIndex := 'Nom';
    end;
1: begin
     { index par socit }
     T_Calepin.IndexName:='IX_Socit';
     { placement des champs dans la grille }
     T_CalepinSocit.index:=0;
     T_CalepinNom.index:=1;
     T_CalepinTlphone.index:=2;
     { nom du champ index en cours }
     ChampIndex:='Socit';
   end;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{ La table se trouve toujours dans le rpertoire de l'EXE }
T_Calepin.TableName:=ExtractFilePath(Application.Exename)+'CALEPIN.DB';
{ ouverture de la table }
T_Calepin.Open;
{ initialisation du champ d'index en cours }
ChampIndex := 'Nom';
{ initialisation du champ de recherche incrmentale }
Edit1.text := '';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
{ fermeture de la table }
T_Calepin.Close;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
{ Edit1  chang, on positionne la table au plus proche }
{ dbut d'un "range" du BDE }
T_calepin.SetRangeStart;
{ on affecte au champ index en cours le texte de Edit1 }
T_Calepin.FieldByName(ChampIndex).AsString:=Edit1.Text;
{ fin de l'opration "range" et application du rsultat }
T_Calepin.ApplyRange;
end;

procedure TForm1.DBRadioGroup1Click(Sender: TObject);
begin
{ si "Socit" est choisi alors DBedit3 est disponible }
DBEdit3.Enabled:= (dbradiogroup1.itemindex=1);
end;

procedure TForm1.ds_CalepinDataChange(Sender: TObject; Field: TField);
begin
{ Field=nil teste le changement de tous les champs en mme temps,
  donc un changement d'enregistrement...
  On peut ainsi mettre en/hors le champ de saisie "socit" suivant
  le contenu du champ qui vient juste d'tre lu. }
if Field=Nil
   then DBEdit3.Enabled:=
    T_CalepinTypeContact.value='Travail';
end;

end.

